#include "StdAfx.h"
#include "RectangleShapePropertyAccessor.h"

#include "ScriptletConstant.h"
#include "RectangleShape.h"

REGISTER_PROPERTY_ACCESSOR(SCRIPTLET_RECTANGLE_NODE, RectangleShapePropertyAccessor)
BOOL RectangleShapePropertyAccessor::SetProperty(CComponent* pTarget, LPCTSTR property, CComVariant value)
{
	BOOL bSuccess = __super::SetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CRectangleShape* rectangle = dynamic_cast<CRectangleShape*>(pTarget);
		if (rectangle == NULL) return bSuccess;

		USES_CONVERSION;
		//background
		if (_tcsicmp(SCRIPTLET_BACKGROUND_NODE, property) == 0)
		{
			COLORREF background = XMLUtil::ColorFromString(OLE2CT(value.bstrVal));
			rectangle->SetBackground(background);
			rectangle->Invalidate();
			bSuccess = TRUE;
		}
	}
	return bSuccess;
}
BOOL RectangleShapePropertyAccessor::GetProperty(CComponent* pTarget, LPCTSTR property, CComVariant& value)
{
	BOOL bSuccess = __super::GetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CRectangleShape* rectangle = dynamic_cast<CRectangleShape*>(pTarget);
		if (rectangle == NULL) return bSuccess;

		USES_CONVERSION;
		//background
		if (_tcsicmp(SCRIPTLET_BACKGROUND_NODE, property) == 0)
		{
			COLORREF background = rectangle->GetBackground();
			value = CComVariant(background);
			bSuccess = TRUE;
		}
	}
	return bSuccess;
}